package Mooix::Session::Socket;
use strict;
use warnings;
use Mooix::Conf;
use Socket;
use base q{Exporter};
our @EXPORT = qw(makesocket);
sub makesocket {
	my $session = shift;
	my @ret;
	my $file = $session->id."/socket";
	my $uaddr = sockaddr_un($file);
	my $proto = getprotobyname('tcp');
	my $fd;
	socket($fd, PF_UNIX, SOCK_STREAM, 0) || die "socket: $!";
	unlink($file);
	bind  ($fd, $uaddr) || die "bind: $!";
	listen($fd, SOMAXCONN) || die "listen: $!";
	chown(scalar getpwnam($Mooix::Conf::field{mooadmin}), -1, $file) || die "chown $file: $!";
	chmod(0600, $file) || die "chmod $file: $!";
	return $fd;
}
1
